'Include file for LibrList.bas

'LibrList History 
'....
'ver 1.16 
'  - uses TPrint instead of XPrint
'ver 1.17
'  - corrected Add initialization giving last edited field entries 
'ver 1.18 (04-13-09)
' - remembers last data file using iniFile
' - added "Not Found" popup for Author/Title find
' - corrected Scottish name capitalization "Mc", "MAC"
' - allow multiple spaces separating names of the author
' - quits program without any prompt if no changes
' - list maintenance for item removal (needed to update books(i).author, callNos, etc)
' - list maintenance for item change (added check on item selection to prevent RPF)
'ver 1.19 (04-15-09)
' - discarded Libr System... not needed, Libr Branch is enough
' - changed mo-year for Pub date back to just year
' - added floating menu 
' - print "Want to read" books with callNo, pub date, reserved date, libr branch
' - print individual book from floating popup menu 
'ver 2.00 (04-15-09)
' - discarded all references to archive
' - eliminated most references to initializeBooks()
' - changed Libr Branchs() to just Librs()
' - cleared Order date when changing 'Want to Read' to 'Have Read' 
'ver 2.01 (04-16-09)
' - cleaned up code and corrected a few minor bugs
' - improved author removal in list maintenance when duplicates exist
'ver 2.02 (04-16-09)
' - increased main dialog width to allow for Library field
' - improved looks of Add Book form
'ver 2.03 (04-20-09)
' - improved custom tab, changing 'List now' to 'Clear'
' - added %BS_DEFAULT style to 'Save Book' button
' - fixed hiLite for added and edited book
' - fixed problem of duplicate author produced by editing a book by that author
'ver 2.04 (04-23-09)
' - expanded custom list to include WantToRead and HaveRead options
' - enhanced display speed with %WM_SETREDRAW in setHiLite() method
'ver 2.05 (04-29-09)
' - corrected problem with selected item in listBooks()
' - improved setHiLite() method in columnListClass.inc
' - improved author/title search (replaced %ID_Go button with red %ID_NotFound label)
'-------------------------------------------------------------------------------------------------- 

'menu system ----------------
%IDM_FileOpen        = 101
%IDM_FileSave        = 102
%IDM_FileSaveAs      = 103 
%IDM_FileArchive     = 104
%IDM_FilePrint       = 105
%IDM_FileSettings    = 106
%IDM_FileExit        = 107 
                                                          
%IDM_AddBook         = 201
%IDM_EditBook        = 202
%IDM_DelBook         = 203
%IDM_PrnBook         = 204 
%IDM_ComboAuthors    = 211
%IDM_ComboCallNos    = 212
%IDM_ComboPubs       = 213
%IDM_ComboLibrs      = 214
%IDM_ComboCatgs      = 215

%IDM_AllBooks        = 301
%IDM_WantToRead      = 302
%IDM_ReadCurrent     = 303
%IDM_ReadArchive     = 304
%IDM_CustomList      = 305
%IDM_ViewBook        = 306
                       
%IDM_HelpContent     = 401
%IDM_HelpAbout       = 402


'tabs ------------------------
%ID_Tab              = 500
%AC_Return           = 501
%AC_Tab              = 502

'toolbar ---------------------
%ID_Toolbar          = 1000
%ID_AddBtn           = 1001
%ID_EditBtn          = 1002
%ID_ViewBtn          = 1003
%ID_PrintBtn         = 1004
%ID_QuitBtn          = 1005
%ID_AuthorTi         = 1006
%ID_NotFound         = 1007

'main controls --------------------
%ID_Status           = 2000

'add/select book controls
%ID_Author           = 2021
%ID_Title            = 2022
%ID_CallNo           = 2023
%ID_Ordered          = 2024
%ID_PubDate          = 2025
%ID_Publisher        = 2026
%ID_Library          = 2027
%ID_Category         = 2028
%ID_AllBooksOpt      = 2030
%ID_NotReadOpt       = 2031
%ID_HaveReadOpt      = 2032
%ID_Comment          = 2033
%ID_All              = 2040
%ID_NotRead          = 2050
%ID_HaveRead         = 2060
%ID_Custom           = 2070
%ID_ByAuthor         = 3001
%ID_ByCatg           = 3002
%ID_CustomList       = 3003
%ID_ClearList        = 3004
'%ID_SaveBook         = 3010

'drop down list maintenance
%ID_DropDnAdd        = 4001
%ID_DropDnChg        = 4002
%ID_DropDnDel        = 4003
%ID_DropDnEdit       = 4004
%ID_DropDnCombo      = 4005

TYPE bookType                '6 + 6 = 12 bytes
     flags AS BYTE              'bit 1 not read, 2 read, 3 custom, 4 delete, 5 display
     author AS WORD             'author's name, index into authors(), 0 to delete
     callNo AS BYTE             'shelf loc, index into callNos()... Fic, Mys, 973.4, etc
     ordered AS WORD            'date book ordered or reserved (otherwise, 0)
     pubDate AS WORD            'year published
     publisher AS BYTE          'publisher's name, index into pubs()
     library AS BYTE            'library system/branch
     futureUse AS BYTE          'reserved for future use
     catg AS BYTE               'type or lit or genre, index into catgs()... adventure, detective, romance, etc
     'title                     'title from titles()
     'comments                  'sources and comments from comments$() 
END TYPE 

GLOBAL hMain AS LONG
GLOBAL hTab AS LONG
GLOBAL hAddBook AS LONG
GLOBAL hMouseMenu AS LONG
GLOBAL mainWidth AS LONG
GLOBAL mainHeight AS LONG
GLOBAL listID AS LONG
GLOBAL tabPage AS LONG
GLOBAL fileChanged AS LONG
GLOBAL numToShow AS LONG  
GLOBAL dataFolder AS STRING 
GLOBAL origDir AS STRING
GLOBAL iniFile AS STRING
GLOBAL thisFile AS STRING
GLOBAL ghKbdHook AS LONG
GLOBAL editAuthor AS LONG
GLOBAL srchAuthorTi AS LONG
GLOBAL listX AS LONG
GLOBAL listY AS LONG
GLOBAL listW AS LONG
GLOBAL listH AS LONG
GLOBAL tabstops() AS LONG
GLOBAL numColumns AS LONG
GLOBAL oColList  AS iColumnList
GLOBAL oColList1 AS iColumnList
GLOBAL oColList2 AS iColumnList
GLOBAL oColList3 AS iColumnList
GLOBAL oColList4 AS iColumnList
GLOBAL oColList5 AS iColumnList
GLOBAL initialized AS LONG
GLOBAL gAuthor AS LONG
GLOBAL numBooks AS LONG
GLOBAL numAuthors AS LONG
GLOBAL numCallNos AS LONG
GLOBAL numPubs AS LONG
GLOBAL numLibrs AS LONG
GLOBAL futureUse AS LONG
GLOBAL numCatgs AS LONG
GLOBAL authors() AS STRING
GLOBAL titles() AS STRING
GLOBAL callNos() AS STRING
GLOBAL pubs() AS STRING
GLOBAL librs() AS STRING
GLOBAL catgs() AS STRING
GLOBAL comments() AS STRING
GLOBAL books() AS bookType
GLOBAL bookNo() AS LONG
GLOBAL tabHandle() AS LONG 

MACRO adjustBookPtrsMacro(xptr)
   FOR i = 1 TO numBooks
      IF xptr > n THEN DECR xptr
   NEXT i
END MACRO

DECLARE FUNCTION HtmlHelp LIB "hhctrl.ocx" ALIAS "HtmlHelpA" _
          (BYVAL LONG, ASCIIZ, BYVAL LONG, BYVAL LONG ) AS LONG 
                           
'Program Notes
'-------------------------------------------------------------------------------------
'bookNo()
'   the listbox component of the object is an unsorted listbox 
'   the defined items of the listbox are ordered by author and title(excluding a,an,the)
'   these ordered items are defined by bookNo(i), where the ith position of the 
'   ordered list is the book in the stored database position at bookNo(i)  
'
'extra()
'   used to keep bookNo() as records are sorted on columns
'   extra() is actually tagged to the ARRAY SORT statements, so that no matter how the
'   list is sorted, bookNo(i) is known for each item... because it moves with the item
'
